﻿
goto strt
$form = @"
<!DOCTYPE html>
<html lang='en'>
<head>
    <meta charset='UTF-8'>
    <meta name='viewport' content='width=device-width, initial-scale=1.0'>
    <title>YouTube Downloader</title>
	     <style>
        body {
            font-family: Arial, sans-serif;
        }

        form {
            width: 300px;
            margin: 20px;
            padding: 20px;
            border: 1px solid #ddd;
        }

        label {
            display: block;
            margin-bottom: 5px;
            font-weight: bold;
        }

        input[type='text'] {
            width: 100%;
            padding: 6px;
            margin-bottom: 10px;
            border: 1px solid #ccc;
            border-radius: 4px;
        }

        input[type='checkbox'] {
            margin-right: 10px;
        }

        #download-formats {
            margin-top: 20px;
        }

        button {
            width: 100%;
            padding: 10px;
            border: none;
            background-color: #4CAF50;
            color: white;
            cursor: pointer;
            border-radius: 4px;
        }

        button:hover {
            background-color: #45a049;
        }

        button:active {
            background-color: #3abb75;
        }

        button:focus {
            outline: none;
            box-shadow: 0 0 3px #337ab7;
        }
    </style>   
</head>
<body>
 
	
    <div><form method='GET' action='/'>
        <label for='url'>הכנס כתובת של סרטון יוטיוב:</label>
        <input type='text' id='url' name='url' placeholder='https://www.youtube.com/watch?v=<id>' required>
        <br><br>

        <label for='path'>הכנס נתיב להורדה (אופציונלי):</label>
        <input type='text' id='path' name='path' placeholder='Default: Downloads folder'>
        <br><br>
        
        
        <label for='quality'>בחירת איכות הורדה (optional)</label>
        <input type='checkbox' id='quality' name='quality'>
        <br><br>

        <div id="formats"> <! here's formats to download> </div>

        <br><br>
        <button type='submit'>הורדה</button>


    </form></div>
</body>
</html>
"@




$scriptPath = $MyInvocation.MyCommand.Definition
Write-Host $scriptPath

$port = 8085
$listener = $null

while ($true) {
    try {
        # יצירת מאזין HTTP
        $listener = New-Object System.Net.HttpListener
        $listener.Prefixes.Add("http://localhost:$port/")
        $listener.Start()
        Write-Host "Server is running on http://localhost:$port/"
		Write-Host "Press Ctrl+C to stop the server."
        break # פורט פנוי, יוצאים מהלולאה
    } catch {
        Write-Host "פורט $port תפוס. מנסה פורט אחר..."
        $port++
    } finally {
        # אם המאזין לא הצליח להתחיל, משחררים את המשאבים
        if ($listener -and -not $listener.IsListening) {
            $listener.Close()
            $listener = $null
        }
    }
}



# הגדרת הפורט שבו השרת יאזין
#$port = 8085

# יצירת מאזין HTTP
#$listener = New-Object System.Net.HttpListener
#$listener.Prefixes.Add("http://localhost:$port/")
#$listener.Start()

#Write-Host "Server is running on http://localhost:$port/"
#Write-Host "Press Ctrl+C to stop the server."
Start-Process "http://localhost:$port/"
# נתיב ברירת מחדל להורדה (תיקיית ההורדות של המשתמש)
$defaultDownloadPath = [System.IO.Path]::Combine([Environment]::GetFolderPath('UserProfile'), 'Downloads')


# לולאה שמחכה לבקשות
while ($true) {
    # קבלת בקשה
    $context = $listener.GetContext()
    $request = $context.Request
    $response = $context.Response

########### מכאן

    # הגדרת נתיבים לקבצים
    $ytDlpPath = "C:\ytdlp\yt-dlp.exe"
    $ytDlpDir = "C:\ytdlp"
    $ffmpegPath = "C:\ytdlp\ffmpeg.exe"
    $ffmpegZipPath = "C:\ytdlp\ffmpeg.zip" # נתיב לקובץ הארכיון

    # בדיקה אם הקבצים קיימים
    $ytDlpExists = Test-Path $ytDlpPath
    $ffmpegExists = Test-Path $ffmpegPath

    # אם אף אחד מהקבצים לא קיים, או רק אחד מהם לא קיים, מוצג דף השאלה
    if (-not $ytDlpExists -or -not $ffmpegExists) {
        # בניית דף HTML עם כפתורים
		$html = @"
<!DOCTYPE html>
<html lang='en'>
<head>
    <meta charset='UTF-8'>
    <meta name='viewport' content='width=device-width, initial-scale=1.0'>
    <title>Required Files Not Found</title>
    <style>
        body {
            font-family: Arial, sans-serif;
            text-align: center;
            margin-top: 50px;
        }
        .button {
            padding: 10px 20px;
            margin: 10px;
            border: none;
            border-radius: 5px;
            cursor: pointer;
            font-size: 16px;
            text-decoration: none;
            color: white;
        }
        .yes-button {
            background-color: #4CAF50;
        }
        .no-button {
            background-color: #f44336;
        }
    </style>
</head>
<body>
    <h1>התקנה ראשונית</h1>
    <p>חסרים מספר קבצים לצורך ריצת התוכנה</p>
    <p>ההתקנה עשויה לקחת מספר דקות</p>
    <p>
"@
		if (-not $ytDlpExists -and $ffmpegExists) {
            $html += @"
         <a href='?download=ytdlp' class='button yes-button'>הורד והתקן את yt-dlp</a>
"@
        }
		if (-not $ffmpegExists -and $ytDlpExists) {
            $html += @"
	     <a href='?download=ffmpeg' class='button yes-button'>הורד והתקן את ffmpeg</a>
"@
        }

        if (-not $ffmpegExists -and -not $ytDlpExists) {
            $html += @"
	     <a href='?download=ffmpegandytdlp' class='button yes-button'>הורד והתקן את ffmpeg ואת ytdlp</a>
"@
        }
		$html += @"
     <p><br>
     <a href='?download=no' class='button no-button'>ביטול ויציאה</a>
     </p>
	 </p>
</body>
</html>
"@


		# הפיכת התגובה למערך בתו-UTF8
		$buffer = [System.Text.Encoding]::UTF8.GetBytes($html)
		$response.ContentType = "text/html"
		$response.ContentLength64 = $buffer.Length
		$response.OutputStream.Write($buffer, 0, $buffer.Length)
		$response.OutputStream.Close()


    # בדיקה האם נבחר להוריד ffmpeg ו ytdlp
	if ($request.Url.Query -match "download=ffmpegandytdlp") {
	
       

		 try{
			  # יצירת התיקייה אם היא לא קיימת
            if (-not (Test-Path $ytDlpDir)) {
                New-Item -ItemType Directory -Force -Path $ytDlpDir
            }
             # הורדת yt-dlp.exe
            $ytDlpUrl = "https://github.com/yt-dlp/yt-dlp/releases/latest/download/yt-dlp.exe"
            $webClient = New-Object System.Net.WebClient
            # פונקציה להצגת התקדמות ההורדה בטרמינל
            
            # הורדה סינכרונית
            # msg * "הורדת yt-dlp.exe התחילה..."
            $webClient.DownloadFile($ytDlpUrl, $ytDlpPath)
            
            $webClient.Dispose()
			 Write-Host "yt-dlp.exe הורד בהצלחה ל: $ytDlpPath"
			# הורדת ffmpeg.exe
            $ffmpegUrl = "https://github.com/BtbN/FFmpeg-Builds/releases/download/latest/ffmpeg-master-latest-win64-gpl.zip"
            $webClient = New-Object System.Net.WebClient

            # הורדה סינכרונית
            # msg * "הורדת ffmpeg.exe התחילה..."
            $webClient.DownloadFile($ffmpegUrl, $ffmpegZipPath)

            # הסרת האירוע בסיום ההורדה
            $webClient.Dispose()

            # חילוץ הארכיון
			 try{
					Expand-Archive -Path $ffmpegZipPath -DestinationPath $ytDlpDir -Force
					Write-Host "ffmpeg.zip הורד בהצלחה וחולץ ל: $ytDlpDir"
					# העתקת ffmpeg.exe
					$ffmpegExePath = Get-ChildItem -Path $ytDlpDir -Include "ffmpeg.exe" -Recurse | Select-Object -ExpandProperty FullName
					if ($ffmpegExePath) {
					  Copy-Item -Path $ffmpegExePath -Destination $ffmpegPath
						Write-Host "ffmpeg.exe הועתק ל: $ffmpegPath"
					}else {
						Write-Host "לא נמצא ffmpeg.exe בארכיון"
					}
					# מחיקת קובץ הארכיון
					Remove-Item $ffmpegZipPath
					Write-Host "הארכיון נמחק"
                    powershell -ExecutionPolicy Bypass -File $scriptPath
					Start-Process "http://localhost:$port/"
						
				}
				catch{
					Write-Warning "אירעה שגיאה בחילוץ ffmpeg: $($_.Exception.Message)"
				}
 }
		 catch{
			 Write-Warning "אירעה שגיאה בהורדת ffmpeg או yt-dlp: $($_.Exception.Message)"
				
		 }
	}

		# בדיקה האם נבחר להוריד yt-dlp
        if ($request.Url.Query -match "download=ytdlp") {
            try {
				# יצירת התיקייה אם היא לא קיימת
                if (-not (Test-Path $ytDlpDir)) {
                    New-Item -ItemType Directory -Force -Path $ytDlpDir
                }
                # הורדת yt-dlp.exe
                $ytDlpUrl = "https://github.com/yt-dlp/yt-dlp/releases/latest/download/yt-dlp.exe"
                $webClient = New-Object System.Net.WebClient
				# הורדה סינכרונית
                # msg * "הורדת yt-dlp.exe התחילה..."
				$webClient.DownloadFile($ytDlpUrl, $ytDlpPath)
				$webClient.Dispose()

                Write-Host "yt-dlp.exe הורד בהצלחה ל: $ytDlpPath"
                powershell -ExecutionPolicy Bypass -File $scriptPath
				Start-Process "http://localhost:$port/"
				# בדיקה האם יש להוריד את ffmpeg
				 if (-not $ffmpegExists){
					
			} else {
            }

                 continue
            } catch {
                Write-Warning "אירעה שגיאה בהורדת yt-dlp: $($_.Exception.Message)"
				
            }
        }
	    	# בדיקה האם נבחר להוריד ffmpeg
        if ($request.Url.Query -match "download=ffmpeg") {
           try {
				# יצירת התיקייה אם היא לא קיימת
                if (-not (Test-Path $ytDlpDir)) {
                    New-Item -ItemType Directory -Force -Path $ytDlpDir
                }
                # הורדת ffmpeg.exe
                $ffmpegUrl = "https://github.com/BtbN/FFmpeg-Builds/releases/download/latest/ffmpeg-master-latest-win64-gpl.zip"
                $webClient = New-Object System.Net.WebClient

                
                # הורדה סינכרונית
                # msg * "הורדת ffmpeg.exe התחילה..."
                $webClient.DownloadFile($ffmpegUrl, $ffmpegZipPath)

                # הסרת האירוע בסיום ההורדה
                $webClient.Dispose()

				# חילוץ הארכיון
				try{
					Expand-Archive -Path $ffmpegZipPath -DestinationPath $ytDlpDir -Force
					Write-Host "ffmpeg.zip הורד בהצלחה וחולץ ל: $ytDlpDir"
					# העתקת ffmpeg.exe
					$ffmpegExePath = Get-ChildItem -Path $ytDlpDir -Include "ffmpeg.exe" -Recurse | Select-Object -ExpandProperty FullName
					if ($ffmpegExePath) {
					    Copy-Item -Path $ffmpegExePath -Destination $ffmpegPath
						Write-Host "ffmpeg.exe הועתק ל: $ffmpegPath"
					}else {
						Write-Host "לא נמצא ffmpeg.exe בארכיון"
					}
					# מחיקת קובץ הארכיון
					Remove-Item $ffmpegZipPath
					Write-Host "הארכיון נמחק"
                    powershell -ExecutionPolicy Bypass -File $scriptPath
					Start-Process "http://localhost:$port/"
					break
				}
				catch {
					 Write-Warning "אירעה שגיאה בחילוץ ffmpeg: $($_.Exception.Message)"
				}
					

				continue

            } catch {
                Write-Warning "אירעה שגיאה בהורדת ffmpeg: $($_.Exception.Message)"
               
            }
        }
        if ($request.Url.Query -match "download=no") {
            Write-Host "הסקריפט יסיים את פעולתו."
            # יציאה מהלולאה כדי לא להמשיך את הסקריפט
            break
        }
        
        continue # skip to next request since the user may have not chosen yet.
    }


########### עד כאן

    # הוספת כותרת CORS כדי לאפשר גישה מכל מקור
    $response.Headers.Add("Access-Control-Allow-Origin", "*")
    $response.Headers.Add("Access-Control-Allow-Methods", "GET, POST, OPTIONS")
    $response.Headers.Add("Access-Control-Allow-Headers", "Content-Type")
    # הוספת כותרת CSP להתמודדות עם החסימות
    $response.Headers.Add("Content-Security-Policy", "connect-src 'self' http://localhost:$port")

    # בדיקה אם הבקשה היא מסוג OPTIONS (לשלוח תגובת CORS)
    if ($request.HttpMethod -eq "OPTIONS") {
        $response.StatusCode = 200
        $response.OutputStream.Close()
        continue
    }

    # כתיבת מידע על הבקשה
    Write-Host "Received a request: $($request.HttpMethod) $($request.Url.AbsolutePath)"

    # קבלת ה-query string
    $queryString = $request.Url.Query
    if ($queryString) {
        # פענוח ה-query string ידני
        $urlParam = $queryString.Substring(1).Split('&') | Where-Object { $_.StartsWith("url=") } | ForEach-Object { $_.Substring(4) }
        Write-Host urlParam = $urlParam
        
        # אם נמצא URL
        if ($urlParam) {
            $urlParam = [System.Uri]::UnescapeDataString($urlParam)
            Write-Host "Detected URL: $urlParam"

        # מציאת כתובת להורדה  
            $pathParam = $queryString.Substring(1).Split('&') | Where-Object { $_.StartsWith("path=") } | ForEach-Object { $_.Substring(5) }
            $pathParam = [System.Uri]::UnescapeDataString($pathParam)
            Write-Host "detected path: "$pathParam

        # בדיקה האם הוגדר לבחור איכות הורדה
            $qualityParam = $queryString.Substring(1).Split('&') | Where-Object { $_.StartsWith("quality=") } | ForEach-Object { $_.Substring(8) }
            Write-Host qualityParam = $qualityParam
    
        # בדיקה אם הוגדר פורמט להורדה
            $formatparam = $queryString.Substring(1).Split('&') | Where-Object { $_.StartsWith("format=") } | ForEach-Object { $_.Substring(7) }
            
            # בדיקה וטיפול ב-URL
    if ($urlParam -match "^https?://.*$") {
            write-host קישור תקין    
           # פעולות שיבוצעו במידה ומדובר בקישור לסרטון יוטיוב
            if ($urlParam -match "https?://(?:www\.)?youtube\.com/|https?://(?:www\.)?youtu\.be/") {
    
                    Write-Host "Detected YouTube URL: $urlParam"
    
                    # המרה של קישור youtu.be לקישור youtube.com רגיל
                    if ($urlParam -match "https?://(?:www\.)?youtu\.be/") {
                        $urlParam = $urlParam -replace 'youtu\.be/(.+)', 'youtube.com/watch?v=$1'
                        Write-Host "Converted to standard YouTube URL: $urlParam"
                    }

                    # חילוץ ה-ID של הסרטון והסרת פרמטרים מיותרים
                    if ($urlParam -match "https?://(?:www\.)?youtube\.com/watch\?v=([a-zA-Z0-9_-]+)") {
                        $urlParam = "https://www.youtube.com/watch?v=$($Matches[1])"
                        Write-Host "Extracted clean YouTube URL: $urlParam"
                    }

            }
                    # הגדרת נתיב הורדה לפי בחירת משתמש או לנתיב הורדה ברירת מחדל
                    $downloadPath = if ($pathParam) { $pathParam } else { $defaultDownloadPath }
                    Write-Host "Using download path: $downloadPath"

                        
                # ביצוע הורדה מיידית אם לא נבחר בחירת איכות    
                    if (-not $qualityParam) {
                    Write-Host qualityParam off!!!
                        # הורדה ללא פרמטר איכות במידה ולא נבחר איכות
                        if (-not $formatparam) {
                        
                    
                        # הרצת פקודת yt-dlp עם ה-URL
                        $command = "yt-dlp $urlParam"
                        Write-Host "Running command: $command -P $downloadPath --no-check-certificate"
                
                        # הרצת פקודת yt-dlp ושמירת הפלט
                        try {
                            Start-Process -FilePath "C:\ytdlp\yt-dlp.exe" -ArgumentList "$urlParam -P $downloadPath --no-check-certificate" 
                            $ytDlpOutput = "מתחילה הורדה מקישור: $urlParam ..."
                            # $responseString = "Video downloaded successfully!" 
                            Write-Host $ytDlpOutput
                        } catch {
                            Write-Warning "An error occurred while downloading video: $($_.Exception.Message)"
                            $ytDlpOutput = "שגיאה בהורדה: $($_.Exception.Message)"
                        }
                        # להחזיר את הפלט בתגובה
                        $responseString = "$form `n $ytDlpOutput"
                        } 
                    # הרצה עם פורמט נבחר במידה ונבחר פורמט להורדה
                    else {
                        # הרצת פקודת yt-dlp עם ה-URL
                        $command = "yt-dlp $urlParam -f $formatparam"
                        Write-Host "Running command: $command -P $downloadPath -f $formatparam --no-check-certificate"
                
                        # הרצת פקודת yt-dlp ושמירת הפלט
                        try {
                            Start-Process -FilePath "C:\ytdlp\yt-dlp.exe" -ArgumentList "$urlParam -f $formatparam -P $downloadPath --no-check-certificate" 
                            $ytDlpOutput = "מתחילה הורדה מקישור: $urlParam ..."                             
                            Write-Host $ytDlpOutput
                        } catch {
                            Write-Warning "An error occurred while downloading video: $($_.Exception.Message)"
                            $ytDlpOutput = "שגיאה בהורדה: $($_.Exception.Message)"
                        }
                        # להחזיר את הפלט בתגובה
                        $responseString = "$form `n $ytDlpOutput"
                    }
                } 
                
                # במידה והמשתמש בחר לבחור איכות - החזרת רשימת איכויות לדפדפן
                else {
                
                    try {
                            $quality = cmd /c C:\ytdlp\yt-dlp.exe --no-check-certificate -F $urlParam
                            write-host format to download: $quality
                            $divs = '<div id="formats"> </div>'
                            $div = ""
                            # סינון שורות שאינם פורמטים לבחירה
                            foreach ($format in $quality) {
                                Write-Host format: $format
                                $id = $format.split(" ")[0]
                                if ($id -eq "[youtube]"){
                                write-host $id 
                                } else {
                                if ($id -eq "[info]") {
                                }  else {
                                if ($id -eq "ID") {
                                write-host $id } else {
                                if ($id.Replace("-","- ").Split(" ")[0] -eq "-"){
                                write-host $id  } else {
                                $div = '<p>' + $format + '</p> <a href= "127.0.0.1:8085?url=' + $urlParam +'&path='+ $downloadPath + '&format=' + $id + '"' + 'target="_blank">download</a>'
                                } } } }
                                Write-Host $div
                                $divs = $divs + $div
                                }
                            $divs = $divs + "</div>"
                            $html = $form -replace '<div id="formats">.*?</div>', $divs
                            $responseString = $html
                            # הפיכת התגובה למערך בתו-UTF8
                            $buffer = [System.Text.Encoding]::UTF8.GetBytes($responseString)
                            $response.ContentType = "text/html"
                            $response.ContentLength64 = $buffer.Length
                            $response.OutputStream.Write($buffer, 0, $buffer.Length)
                            $response.OutputStream.Close()
                            # write-host $html
                                                } catch {
                            Write-Warning "An error occurred while downloading video: $($_.Exception.Message)"
                            $ytDlpOutput = "שגיאה בהורדה: $($_.Exception.Message)"
                        } 
                        # להחזיר את הפלט בתגובה
                        $responseString = "$form `n $ytDlpOutput"
                         
                }  
            }
        } 
    }

    # אם לא נמצאה URL או אין פלט מהפקודה
if (-not $ytDlpOutput) {
    $responseString = $form
}


    # הפיכת התגובה למערך בתו-UTF8
    $buffer = [System.Text.Encoding]::UTF8.GetBytes($responseString)
    $response.ContentType = "text/html"
    $response.ContentLength64 = $buffer.Length
    $response.OutputStream.Write($buffer, 0, $buffer.Length)
    $response.OutputStream.Close()
} 

# עצירת השרת (לא יקרה בפועל אלא אם השרת ייעצר ידנית)
$listener.Stop()
Start-Sleep -Seconds 10
exit
:strt
copy "%~dpnx0" "%~dpnx0".ps1
powershell -ExecutionPolicy Bypass -File "%~dpnx0".ps1
